PingOne Platform APIs - Early Access

Update Authorization Rule

 

PUT {{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}

The PUT {{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}} request updates the authorization rule specified by its ID in the request URL.

The update action requires that you specify the authorization conditions ID and the version ID in the request body.

Request Model

For property descriptions, refer to Authorization conditions data model

Property Type? Required?

condition

Object

Optional

description

String

Optional

effectSettings

Object

Optional

enabled

Boolean

Optional

id

String

Required

name

String

Required

statements

Object

Optional

type

String

Optional

version

String

Required

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

Body

raw ( application/json )

{
  "id": "{{authorizationRuleID}}",
  "version": "{{authorizationRuleVersionID}}",
  "type": "RULE",
  "name": "Rule10",
  "description": "Rule10 description",
  "enabled": true,
  "statements": [
    {
      "type": "STATEMENT_REFERENCE",
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "type": "EMBEDDED_STATEMENT",
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "effectSettings": {
    "type": "UNCONDITIONAL_PERMIT"
  }
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff --request PUT '{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
  "id": "{{authorizationRuleID}}",
  "version": "{{authorizationRuleVersionID}}",
  "type": "RULE",
  "name": "Rule10",
  "description": "Rule10 description",
  "enabled": true,
  "statements": [
    {
      "type": "STATEMENT_REFERENCE",
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "type": "EMBEDDED_STATEMENT",
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "effectSettings": {
    "type": "UNCONDITIONAL_PERMIT"
  }
}'
var options = new RestClientOptions("{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"  ""id"": ""{{authorizationRuleID}}""," + "\n" +
@"  ""version"": ""{{authorizationRuleVersionID}}""," + "\n" +
@"  ""type"": ""RULE""," + "\n" +
@"  ""name"": ""Rule10""," + "\n" +
@"  ""description"": ""Rule10 description""," + "\n" +
@"  ""enabled"": true," + "\n" +
@"  ""statements"": [" + "\n" +
@"    {" + "\n" +
@"      ""type"": ""STATEMENT_REFERENCE""," + "\n" +
@"      ""value"": {" + "\n" +
@"        ""id"": ""{{authorizationStatementID}}""" + "\n" +
@"      }" + "\n" +
@"    }," + "\n" +
@"    {" + "\n" +
@"      ""type"": ""EMBEDDED_STATEMENT""," + "\n" +
@"      ""name"": ""Statement1""," + "\n" +
@"      ""description"": ""Statement1 description""," + "\n" +
@"      ""code"": ""CODE1""," + "\n" +
@"      ""appliesTo"": ""PERMIT_OR_DENY""," + "\n" +
@"      ""appliesIf"": ""FINAL_DECISION_MATCHES""," + "\n" +
@"      ""payload"": ""Payload1""," + "\n" +
@"      ""obligatory"": false," + "\n" +
@"      ""attributes"": []," + "\n" +
@"      ""services"": []" + "\n" +
@"    }" + "\n" +
@"  ]," + "\n" +
@"  ""condition"": {" + "\n" +
@"    ""type"": ""AND""," + "\n" +
@"    ""conditions"": [" + "\n" +
@"      {" + "\n" +
@"        ""type"": ""COMPARISON""," + "\n" +
@"        ""left"": {" + "\n" +
@"          ""type"": ""ATTRIBUTE""," + "\n" +
@"          ""id"": ""{{authAttributeID}}""" + "\n" +
@"        }," + "\n" +
@"        ""comparator"": ""EQUALS""," + "\n" +
@"        ""right"": {" + "\n" +
@"          ""type"": ""CONSTANT""," + "\n" +
@"          ""value"": ""def""        " + "\n" +
@"        }" + "\n" +
@"      }" + "\n" +
@"    ]" + "\n" +
@"  }," + "\n" +
@"  ""effectSettings"": {" + "\n" +
@"    ""type"": ""UNCONDITIONAL_PERMIT""" + "\n" +
@"  }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}"
  method := "PUT"

  payload := strings.NewReader(`{
  "id": "{{authorizationRuleID}}",
  "version": "{{authorizationRuleVersionID}}",
  "type": "RULE",
  "name": "Rule10",
  "description": "Rule10 description",
  "enabled": true,
  "statements": [
    {
      "type": "STATEMENT_REFERENCE",
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "type": "EMBEDDED_STATEMENT",
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "effectSettings": {
    "type": "UNCONDITIONAL_PERMIT"
  }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
PUT /environments/{{envID}}/authorizationRules/{{authorizationRuleID}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
  "id": "{{authorizationRuleID}}",
  "version": "{{authorizationRuleVersionID}}",
  "type": "RULE",
  "name": "Rule10",
  "description": "Rule10 description",
  "enabled": true,
  "statements": [
    {
      "type": "STATEMENT_REFERENCE",
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "type": "EMBEDDED_STATEMENT",
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "effectSettings": {
    "type": "UNCONDITIONAL_PERMIT"
  }
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n  \"id\": \"{{authorizationRuleID}}\",\n  \"version\": \"{{authorizationRuleVersionID}}\",\n  \"type\": \"RULE\",\n  \"name\": \"Rule10\",\n  \"description\": \"Rule10 description\",\n  \"enabled\": true,\n  \"statements\": [\n    {\n      \"type\": \"STATEMENT_REFERENCE\",\n      \"value\": {\n        \"id\": \"{{authorizationStatementID}}\"\n      }\n    },\n    {\n      \"type\": \"EMBEDDED_STATEMENT\",\n      \"name\": \"Statement1\",\n      \"description\": \"Statement1 description\",\n      \"code\": \"CODE1\",\n      \"appliesTo\": \"PERMIT_OR_DENY\",\n      \"appliesIf\": \"FINAL_DECISION_MATCHES\",\n      \"payload\": \"Payload1\",\n      \"obligatory\": false,\n      \"attributes\": [],\n      \"services\": []\n    }\n  ],\n  \"condition\": {\n    \"type\": \"AND\",\n    \"conditions\": [\n      {\n        \"type\": \"COMPARISON\",\n        \"left\": {\n          \"type\": \"ATTRIBUTE\",\n          \"id\": \"{{authAttributeID}}\"\n        },\n        \"comparator\": \"EQUALS\",\n        \"right\": {\n          \"type\": \"CONSTANT\",\n          \"value\": \"def\"        \n        }\n      }\n    ]\n  },\n  \"effectSettings\": {\n    \"type\": \"UNCONDITIONAL_PERMIT\"\n  }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "id": "{{authorizationRuleID}}",
    "version": "{{authorizationRuleVersionID}}",
    "type": "RULE",
    "name": "Rule10",
    "description": "Rule10 description",
    "enabled": true,
    "statements": [
      {
        "type": "STATEMENT_REFERENCE",
        "value": {
          "id": "{{authorizationStatementID}}"
        }
      },
      {
        "type": "EMBEDDED_STATEMENT",
        "name": "Statement1",
        "description": "Statement1 description",
        "code": "CODE1",
        "appliesTo": "PERMIT_OR_DENY",
        "appliesIf": "FINAL_DECISION_MATCHES",
        "payload": "Payload1",
        "obligatory": false,
        "attributes": [],
        "services": []
      }
    ],
    "condition": {
      "type": "AND",
      "conditions": [
        {
          "type": "COMPARISON",
          "left": {
            "type": "ATTRIBUTE",
            "id": "{{authAttributeID}}"
          },
          "comparator": "EQUALS",
          "right": {
            "type": "CONSTANT",
            "value": "def"
          }
        }
      ]
    },
    "effectSettings": {
      "type": "UNCONDITIONAL_PERMIT"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "id": "{{authorizationRuleID}}",
    "version": "{{authorizationRuleVersionID}}",
    "type": "RULE",
    "name": "Rule10",
    "description": "Rule10 description",
    "enabled": true,
    "statements": [
      {
        "type": "STATEMENT_REFERENCE",
        "value": {
          "id": "{{authorizationStatementID}}"
        }
      },
      {
        "type": "EMBEDDED_STATEMENT",
        "name": "Statement1",
        "description": "Statement1 description",
        "code": "CODE1",
        "appliesTo": "PERMIT_OR_DENY",
        "appliesIf": "FINAL_DECISION_MATCHES",
        "payload": "Payload1",
        "obligatory": false,
        "attributes": [],
        "services": []
      }
    ],
    "condition": {
      "type": "AND",
      "conditions": [
        {
          "type": "COMPARISON",
          "left": {
            "type": "ATTRIBUTE",
            "id": "{{authAttributeID}}"
          },
          "comparator": "EQUALS",
          "right": {
            "type": "CONSTANT",
            "value": "def"
          }
        }
      ]
    },
    "effectSettings": {
      "type": "UNCONDITIONAL_PERMIT"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}"

payload = json.dumps({
  "id": "{{authorizationRuleID}}",
  "version": "{{authorizationRuleVersionID}}",
  "type": "RULE",
  "name": "Rule10",
  "description": "Rule10 description",
  "enabled": True,
  "statements": [
    {
      "type": "STATEMENT_REFERENCE",
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "type": "EMBEDDED_STATEMENT",
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": False,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "effectSettings": {
    "type": "UNCONDITIONAL_PERMIT"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n  "id": "{{authorizationRuleID}}",\n  "version": "{{authorizationRuleVersionID}}",\n  "type": "RULE",\n  "name": "Rule10",\n  "description": "Rule10 description",\n  "enabled": true,\n  "statements": [\n    {\n      "type": "STATEMENT_REFERENCE",\n      "value": {\n        "id": "{{authorizationStatementID}}"\n      }\n    },\n    {\n      "type": "EMBEDDED_STATEMENT",\n      "name": "Statement1",\n      "description": "Statement1 description",\n      "code": "CODE1",\n      "appliesTo": "PERMIT_OR_DENY",\n      "appliesIf": "FINAL_DECISION_MATCHES",\n      "payload": "Payload1",\n      "obligatory": false,\n      "attributes": [],\n      "services": []\n    }\n  ],\n  "condition": {\n    "type": "AND",\n    "conditions": [\n      {\n        "type": "COMPARISON",\n        "left": {\n          "type": "ATTRIBUTE",\n          "id": "{{authAttributeID}}"\n        },\n        "comparator": "EQUALS",\n        "right": {\n          "type": "CONSTANT",\n          "value": "def"        \n        }\n      }\n    ]\n  },\n  "effectSettings": {\n    "type": "UNCONDITIONAL_PERMIT"\n  }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "id": "{{authorizationRuleID}}",
  "version": "{{authorizationRuleVersionID}}",
  "type": "RULE",
  "name": "Rule10",
  "description": "Rule10 description",
  "enabled": true,
  "statements": [
    {
      "type": "STATEMENT_REFERENCE",
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "type": "EMBEDDED_STATEMENT",
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "effectSettings": {
    "type": "UNCONDITIONAL_PERMIT"
  }
})

response = http.request(request)
puts response.read_body
let parameters = "{\n  \"id\": \"{{authorizationRuleID}}\",\n  \"version\": \"{{authorizationRuleVersionID}}\",\n  \"type\": \"RULE\",\n  \"name\": \"Rule10\",\n  \"description\": \"Rule10 description\",\n  \"enabled\": true,\n  \"statements\": [\n    {\n      \"type\": \"STATEMENT_REFERENCE\",\n      \"value\": {\n        \"id\": \"{{authorizationStatementID}}\"\n      }\n    },\n    {\n      \"type\": \"EMBEDDED_STATEMENT\",\n      \"name\": \"Statement1\",\n      \"description\": \"Statement1 description\",\n      \"code\": \"CODE1\",\n      \"appliesTo\": \"PERMIT_OR_DENY\",\n      \"appliesIf\": \"FINAL_DECISION_MATCHES\",\n      \"payload\": \"Payload1\",\n      \"obligatory\": false,\n      \"attributes\": [],\n      \"services\": []\n    }\n  ],\n  \"condition\": {\n    \"type\": \"AND\",\n    \"conditions\": [\n      {\n        \"type\": \"COMPARISON\",\n        \"left\": {\n          \"type\": \"ATTRIBUTE\",\n          \"id\": \"{{authAttributeID}}\"\n        },\n        \"comparator\": \"EQUALS\",\n        \"right\": {\n          \"type\": \"CONSTANT\",\n          \"value\": \"def\"        \n        }\n      }\n    ]\n  },\n  \"effectSettings\": {\n    \"type\": \"UNCONDITIONAL_PERMIT\"\n  }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/environments/{{envID}}/authorizationRules/{{authorizationRuleID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

200 OK

{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/authorizationRules/bdb2f5ac-f0a5-490e-bd01-3aff8682d898"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "id": "bdb2f5ac-f0a5-490e-bd01-3aff8682d898",
    "name": "Rule10",
    "description": "Rule10 updated description",
    "enabled": true,
    "statements": [
        {
            "value": {
                "id": "20a1d298-ca8d-4e58-859f-b2b8d123286d"
            }
        },
        {
            "name": "Statement1",
            "description": "Statement1 description",
            "code": "CODE1",
            "appliesTo": "PERMIT_OR_DENY",
            "appliesIf": "FINAL_DECISION_MATCHES",
            "payload": "Payload1",
            "obligatory": false,
            "attributes": []
        }
    ],
    "condition": {
        "type": "AND",
        "conditions": [
            {
                "type": "COMPARISON",
                "left": {
                    "type": "ATTRIBUTE",
                    "id": "a82a932f-f8bd-4b05-8c1f-5cf75c8fc030"
                },
                "comparator": "EQUALS",
                "right": {
                    "type": "CONSTANT",
                    "value": "def"
                }
            }
        ]
    },
    "effectSettings": {
        "type": "UNCONDITIONAL_PERMIT"
    },
    "version": "a62a6b83-42a0-4df0-88b3-88cae46d3b1c"
}